#include <math.h>
#include <stdio.h>
#include <conio.h>

void main (int argc, char *argv[])
{
  int n, i, Z1[8], Z2[8], d1[8], d2[8], b1[8], b2[8];
  float Upf, m, k, l, a, Up, Ucp, U[8], Uf[8], T[9], w[9];
  FILE *f;
  long j;

  asm
  {
    mov ax, 4F02h
    mov bx, 10Ah
    int 10h
  }

  clrscr();

  if (argc < 2 )
    f = fopen("con", "wt");
  else
    f = fopen(argv[1], "wt");

  fprintf(f, "Up = ");
  scanf("%f", &Up);

  if (argc > 1 ) fprintf(f, "%5.0f\n", Up);

  if ((Up < 10) | (Up > 20000)) return;

  if ((Up>9) && (Up<18)) n = 3;
  if ((Up>17) && (Up<75)) n = 4;
  if ((Up>74) && (Up<300)) n = 5;
  if ((Up>299) && (Up<1250)) n = 6;
  if ((Up>1249) && (Up<5000)) n = 7;
  if ((Up>4999) && (Up<20001)) n = 8;

  m = n;
  Ucp = pow(Up, 1 / m);
  if (f) fprintf(f,"Ucp = %.3f\n", Ucp);

  if (n == 3)
  {
    U[0] = 1.25 * sqrt(Ucp);
    U[1] = Ucp;
    U[2] = Up / (U[0] * U[1]);
  }
  if (n == 4)
  {
    U[0] = 1.175 * pow(Ucp, 1 / 3);
    U[1] = 1.13 * pow(Ucp * Ucp, 1 / 3);
    U[2] = Ucp * Ucp / U[1];
    U[3] = Up / (U[0] * U[1] * U[2]);
  }
  if (n >= 5)
  {
    U[0] = pow(Ucp * 2, 0.25);
    U[1] = sqrt(Ucp);
    for (i = 0; i < n - 4; i++)
      U[i + 2] = Ucp;
    U[n - 2] = Ucp * Ucp / U[1];
    Upf = 1;
    for (i = 0; i < n - 1; i++)
      Upf *= U[i];
    U[n - 1] = Up / Upf;
  }

  l = -2;
  j = 0;
  do
  {
    Upf = 1;
    for (i = 0; i < n; i++)
    {
      Z1[i] = ceil(8 / (m - 1) * i + 18);
      Z2[i] = ceil(Z1[i] * U[i] + l);
      Uf[i] = Z2[i] * 1.0 / (Z1[i] * 1.0);
      k = (5 / (m - 1) * i + 3) / 10;
      d1[i] = ceil(Z1[i] * k);
      d2[i] = ceil(Z2[i] * k);
      Upf *= Uf[i];
    }
    l += 0.001;
    j++;
  } while ((fabs(100 - (Upf / Up * 100)) > 1.0) && (j < 4000));

  if (f)
  {
    fprintf(f, "\nUp = %.0f  Uf = %.4f  譮 %2.2f%%  ", Up, Upf, fabs(100 - (Upf / Up * 100)));
    fprintf(f, "\n\nĿ\n");
    fprintf(f, " N    U      Uf    Z1   Z2   d1   d2   Qw  b1  b2   m      w        T    \n");
    fprintf(f, "Ĵ\n");
  }

  w[0] = 3.141592654 * 14000 / 30;
  T[0] = 0.5 / w[0]* 1000;

  for (i = 0; i < n + 1; i++)
  {
    k = (3 / (m - 1) * i + 3) / 10;
    k = k * (5 / (m - 1) * i + 3);
    b2[i] = ceil(k);
    b1[i] = ceil(b2[i] * 1.6);
    if (i < n) w[i + 1] = w[i] / Uf[i];
    k = (5 / (m - 1) * i + 3) / 10;
    if (i < n) T[i + 1] = 0.5 * pow(0.97, i - 1) / w[i + 1] * 1000;
    if (f)
    {
      fprintf(f, " %d ", i + 1);
      if (i < n)
      {
        fprintf(f, " %5.3f ", U[i]);
        fprintf(f, " %5.3f ", Uf[i]);
        fprintf(f, " %3d ", Z1[i]);
        fprintf(f, " %3d ", Z2[i]);
        fprintf(f, " %3d ", d1[i]);
        fprintf(f, " %3d ", d2[i]);
        fprintf(f, " %3d ", (d2[i] + d1[i]) / 2);
        fprintf(f, " %2d ", b1[i]);
        fprintf(f, " %2d ", b2[i]);
        fprintf(f, " %1.1f ", k);
      }
      else
        fprintf(f, "                                                    ");
      fprintf(f, " %7.2f ", w[i]);
      fprintf(f, " %7.2f \n", T[i]);
    }
  }
  if (f)
    fprintf(f, "\n");

  if (f) fclose(f);

  getch();
  asm
  {
    mov ax, 3
    int 10h
  }
}












